--- /dev/null	Sat May 10 12:09:02 2014
+++ new/usr/src/lib/libm/common/Q/_TBL_atanl.c	Sat May 10 12:09:02 2014
@@ -0,0 +1,235 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+ */
+/*
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*
+ * Table of constants for atanl.
+ * By K.C. Ng, March 9, 1989
+ */
+
+#include "libm.h"
+
+const long double _TBL_atanl_hi[] = {
+	+1.243549945467614350313548491638710241657e-0001L,
+	+1.320397616146387492746844065265695322625e-0001L,
+	+1.397088742891636451833677767390950568161e-0001L,
+	+1.473614810886516356098027603968455182107e-0001L,
+	+1.549967419239409823037143749334921913337e-0001L,
+	+1.626138285979485753736415637615578006202e-0001L,
+	+1.702119252854744044904966070997617136954e-0001L,
+	+1.777902289926760707966247992158246889946e-0001L,
+	+1.853479499956947648860259612285446466726e-0001L,
+	+1.928843122579746641970587106902273034988e-0001L,
+	+2.003985538258785146539457850343783844615e-0001L,
+	+2.078899272022629936053349831029943247563e-0001L,
+	+2.153576996977380480244596271664896416574e-0001L,
+	+2.228011537593945157710321221404325552502e-0001L,
+	+2.302195872768437302401709596798029906555e-0001L,
+	+2.376123138654712524738836343256377791989e-0001L,
+	+2.449786631268641541720824812112758064196e-0001L,
+	+2.596296294082575310299464431839719056011e-0001L,
+	+2.741674511196587975993718983421757859244e-0001L,
+	+2.885873618940773956236114199582183450433e-0001L,
+	+3.028848683749714055605560945055582181228e-0001L,
+	+3.170557532091470098090155766744673297585e-0001L,
+	+3.310960767041320949443387877569445542126e-0001L,
+	+3.450021772071051088676812869000516840829e-0001L,
+	+3.587706702705722203959200639264605221536e-0001L,
+	+3.723984466767542219236550382837018264141e-0001L,
+	+3.858826693980737758976954846072313963819e-0001L,
+	+3.992207695752525656147166961588647649110e-0001L,
+	+4.124104415973873068997912896671269426092e-0001L,
+	+4.254496373700422895422636051807923301382e-0001L,
+	+4.383365598579578054456160492147713089588e-0001L,
+	+4.510696559885234763756392572821934407380e-0001L,
+	+4.636476090008061162142562314612143971334e-0001L,
+	+4.883339510564055238671649607470648445964e-0001L,
+	+5.123894603107377066666010205842592380556e-0001L,
+	+5.358112379604637002690850687076914469847e-0001L,
+	+5.585993153435624359715082164016612287587e-0001L,
+	+5.807563535676703992032744750015008237512e-0001L,
+	+6.022873461349641816821226942042329192246e-0001L,
+	+6.231993299340659309924753490603745936779e-0001L,
+	+6.435011087932843868028092287173226044727e-0001L,
+	+6.632029927060932553632543102382758341723e-0001L,
+	+6.823165548747480782564299817111529878473e-0001L,
+	+7.008544078844501724579512817867512731862e-0001L,
+	+7.188299996216245054170141515259046989104e-0001L,
+	+7.362574289814281317428352710891466247927e-0001L,
+	+7.531512809621943895247393702690288860057e-0001L,
+	+7.695264804056582604068200359856540172660e-0001L,
+	+7.853981633974483096156608458198756993698e-0001L,
+	+8.156919233162234110214608387456458267228e-0001L,
+	+8.441539861131710025178441482716474673863e-0001L,
+	+8.709034570756529531401731125978140729165e-0001L,
+	+8.960553845713439561748007180299377954660e-0001L,
+	+9.197196053504168172286034548210894096931e-0001L,
+	+9.420000403794636647379371705345936211589e-0001L,
+	+9.629943306809362018151958359970998967730e-0001L,
+	+9.827937232473290679857106110146660376257e-0001L,
+	+1.001483135694234732918329595301437489634e+0000L,
+	+1.019141344266349734638342917023063621235e+0000L,
+	+1.035841253008800176584694470325444073548e+0000L,
+	+1.051650212548373667459867312086299902692e+0000L,
+	+1.066630365315743563079176347420279908601e+0000L,
+	+1.080839000541168310887156729217199785900e+0000L,
+	+1.094328907321189919892788314610235276303e+0000L,
+	+1.107148717794090503017065460178537049754e+0000L,
+	+1.130953743979160446470933515536327756003e+0000L,
+	+1.152571997215667518040149862612751467283e+0000L,
+	+1.172273881128476386600594944133704600686e+0000L,
+	+1.190289949682531732927733774829318280338e+0000L,
+	+1.206817370285252530395511580056557662568e+0000L,
+	+1.222025323210989637041741743922570412029e+0000L,
+	+1.236059489478081941909451971109078614621e+0000L,
+	+1.249045772398254425829917077281090048355e+0000L,
+	+1.261093382252440419313940881247335764012e+0000L,
+	+1.272297395208717341296193749822480574646e+0000L,
+	+1.282740879744270747362885251136495516407e+0000L,
+	+1.292496667789785267903091421407081672353e+0000L,
+	+1.301628834009196143804785850366685502445e+0000L,
+	+1.310193935047555634256437689171905343754e+0000L,
+	+1.318242051016837049859330202327136304043e+0000L,
+	+1.325817663668032465059239210428475688616e+0000L,
+	+1.339705659598999539328303752589555785024e+0000L,
+	+1.352127380920954657189147941389812759877e+0000L,
+	+1.363300100359693954289298527825099156027e+0000L,
+	+1.373400766945015860861271926444961060484e+0000L,
+	+1.382574821490125858059967417768568516395e+0000L,
+	+1.390942827002418348642768694383643239549e+0000L,
+	+1.398605512271957595012670081611428272786e+0000L,
+	+1.405647649380269780952193401995808066441e+0000L,
+	+1.412141064608495215367613671858489085282e+0000L,
+	+1.418146998399631459403860303970098863261e+0000L,
+	+1.423717971406494118901819046610729710890e+0000L,
+	+1.428899272190732696418470074537198400139e+0000L,
+	+1.433730152484708986640471909669887388026e+0000L,
+	+1.438244794498222597961404247935481603967e+0000L,
+	+1.442473099109101820025292059937729181035e+0000L,
+	+1.446441332248135184199966842475880386611e+0000L,
+};
+
+const long double _TBL_atanl_lo[] = {
+	+1.407486919762806380231720282041430859065e-0036L,
+	-4.959696159473992555573043943799966949987e-0036L,
+	+8.952774562519464887393121344636183788152e-0036L,
+	+1.188043742320789571818076584354496443030e-0035L,
+	-2.781027811204514537842537512823435451463e-0037L,
+	+1.479722037702380032729553623431514726239e-0036L,
+	-4.216956140054819873287038480184963406819e-0036L,
+	+7.243122966691348464993032365631602349468e-0036L,
+	-2.157343008983917029989567935379065159119e-0036L,
+	-9.951574540512672355445236729812860518631e-0036L,
+	-3.906555899232483818161756973039787656743e-0036L,
+	+5.526029227179372681321198066466113031444e-0036L,
+	+8.841572221591432180768225431803645204369e-0036L,
+	-8.176772879158617925419332362828558820944e-0036L,
+	-1.334412303465614224379711382302833876421e-0036L,
+	-4.492733120781338290893073392468132589219e-0036L,
+	+4.494551147181249039320182433676250148336e-0036L,
+	-1.668808150427922355577672445964844056727e-0035L,
+	+1.562975758610795576946108656893732968411e-0035L,
+	-2.238983556330807855250797038533151084811e-0035L,
+	-4.831232174554731155187045067118216295832e-0036L,
+	-1.433617235290583287695892661098069884431e-0035L,
+	-8.744018199889993280298917417096058172481e-0036L,
+	+5.928463600852983744578036078546455593865e-0036L,
+	-2.237665124843624127606105529504351499363e-0035L,
+	+6.074583759933610541428031075667744213648e-0036L,
+	+1.537218711045194967779234476202996702309e-0035L,
+	+2.097606805675115624165712158247879024716e-0035L,
+	-5.562395640549543806072686220262281911497e-0036L,
+	+1.969736670783247184185841193489735190152e-0035L,
+	+2.107031196447948850903473363942488754370e-0035L,
+	-2.302735636298200160225651851085422984456e-0035L,
+	+4.895096422573334926686184352202977056848e-0036L,
+	-7.238014347779445821387272305082026475766e-0036L,
+	+1.636564886570361403163744339604956885811e-0035L,
+	-3.988581195823453079372912991980323419740e-0035L,
+	+4.158772212091261351041778392322742597344e-0035L,
+	+3.834742145455647215368468737733713502739e-0035L,
+	-9.225117893363872172351589646548899090659e-0036L,
+	+1.409461969045598952617573674185465039654e-0036L,
+	+3.356885780547223527061285142581080367945e-0035L,
+	+3.909099105552255239501810680323211880340e-0035L,
+	+5.295641697965420814052186270729703965359e-0036L,
+	-5.096084681994551436784706392366250713672e-0036L,
+	-4.495901442527761585832968039391831520500e-0035L,
+	+3.803922654455163426656685761596261429034e-0035L,
+	-4.405652287289551210830864219661168965762e-0036L,
+	+1.602502419248216107622380775342561907695e-0036L,
+	+2.167952532530945256199261006510838063526e-0035L,
+	+1.984403801351542212571536292573675410407e-0035L,
+	+3.913961947179974683450522735356843245724e-0035L,
+	+2.111344380797545350551845343679956185473e-0035L,
+	+3.155855727744469275503981694439277018543e-0035L,
+	+1.629504452035546140826558561950023833561e-0035L,
+	-3.508724520927030585615123035617120894580e-0035L,
+	+2.904104186428285567959105527094611730009e-0035L,
+	-2.312884345381835659093199520980662723328e-0035L,
+	-7.712492318147157843996797382071597987481e-0035L,
+	+2.753902782988692242909206359044995381933e-0035L,
+	-9.450089945318130895108454599083752773445e-0035L,
+	-7.306175530203209233759494600164318159101e-0035L,
+	-4.173614481395375219395277015740431906643e-0035L,
+	+3.436994835625640704534485526286425749647e-0035L,
+	-6.379024349229809090730208492427563489748e-0035L,
+	-9.684294381635326129100412786609400488464e-0036L,
+	+4.874675753913887090927595832669806057728e-0035L,
+	-8.753388647708419088451160136858547852751e-0035L,
+	+1.428474399232791889269255113808220484160e-0035L,
+	+5.726277621107338954256562569347449057228e-0035L,
+	-3.225488314878041124559482227075035491317e-0035L,
+	+7.885354819060987732596552525237673513561e-0035L,
+	+8.408173673903719409751503836536882928318e-0035L,
+	+7.472287035756368381507824298193454239425e-0035L,
+	+7.997720282579343528943481360087007043974e-0036L,
+	-8.057784077336213905484849234629395332153e-0035L,
+	+1.421774675367058306549004020905308580426e-0035L,
+	+1.223248691422120500410974356032312699327e-0035L,
+	+8.969605507083003644736195721794664042146e-0035L,
+	-3.148039443508188441068606673984936704609e-0035L,
+	-5.092714604071534501324064251761157116236e-0035L,
+	-5.743199771592413656813385943270585886166e-0035L,
+	-4.392045140508377027909976608047950844300e-0035L,
+	+9.110675398490771556301866677631321964372e-0035L,
+	-3.703256901427284100951240077306435653503e-0035L,
+	+8.816741942974671427690982540513176913907e-0035L,
+	-3.838934169602835250375231286170331051923e-0036L,
+	-3.346295934196089154634089550801425121335e-0035L,
+	-3.921262677678607438391618849895555508099e-0035L,
+	-7.834039739637786725586449456859141775022e-0035L,
+	+7.468101863245698652060064034062436100558e-0035L,
+	+8.911091861895691845113559487616548179839e-0035L,
+	+3.941816063227189053043179714566870857491e-0035L,
+	-4.104811408858010482019343563832718161219e-0035L,
+	-2.316541945158215332638394475622094450115e-0035L,
+	-1.842831258152531940939933020370545982007e-0035L,
+	+7.147731654670948234541171201790940212220e-0035L,
+	+2.991450157843587466215363770701953452571e-0035L,
+};