--- /dev/null	Sat May 10 12:09:02 2014
+++ new/usr/src/lib/libm/common/Q/_TBL_expl.c	Sat May 10 12:09:02 2014
@@ -0,0 +1,105 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+ */
+/*
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*
+ * Table of constants for expl.
+ * By K.C. Ng, March 9, 1989
+ */
+
+#include "libm.h"
+
+const long double _TBL_expl_hi[] = {
+	+1.000000000000000000000000000000000000000e+0000L,
+	+1.021897148654116678234480134783299439782e+0000L,
+	+1.044273782427413840321966478739929008785e+0000L,
+	+1.067140400676823618169521120992809162607e+0000L,
+	+1.090507732665257659207010655760707978993e+0000L,
+	+1.114386742595892536308812956919603067800e+0000L,
+	+1.138788634756691653703830283841511254720e+0000L,
+	+1.163724858777577513813573599092185312343e+0000L,
+	+1.189207115002721066717499970560475915293e+0000L,
+	+1.215247359980468878116520251338798457624e+0000L,
+	+1.241857812073484048593677468726595605511e+0000L,
+	+1.269050957191733222554419081032338004715e+0000L,
+	+1.296839554651009665933754117792451159835e+0000L,
+	+1.325236643159741294629537095498721674113e+0000L,
+	+1.354255546936892728298014740140702804343e+0000L,
+	+1.383909881963831954872659527265192818002e+0000L,
+	+1.414213562373095048801688724209698078570e+0000L,
+	+1.445180806977046620037006241471670905678e+0000L,
+	+1.476826145939499311386907480374049923924e+0000L,
+	+1.509164427593422739766019551033193531420e+0000L,
+	+1.542210825407940823612291862090734841307e+0000L,
+	+1.575980845107886486455270160181905008906e+0000L,
+	+1.610490331949254308179520667357400583459e+0000L,
+	+1.645755478153964844518756724725822445667e+0000L,
+	+1.681792830507429086062250952466429790080e+0000L,
+	+1.718619298122477915629344376456312504516e+0000L,
+	+1.756252160373299483112160619375313221294e+0000L,
+	+1.794709075003107186427703242127781814354e+0000L,
+	+1.834008086409342463487083189588288856077e+0000L,
+	+1.874167634110299901329998949954446534439e+0000L,
+	+1.915206561397147293872611270295830887850e+0000L,
+	+1.957144124175400269018322251626871491190e+0000L,
+};
+
+const long double _TBL_expl_lo[] = {
+	+0.000000000000000000000000000000000000000e+0000L,
+	+1.805067874203309547455733330545737864651e-0035L,
+	-9.374520292280427421957567419730832143843e-0035L,
+	-1.596968447292758770712909630231499971233e-0035L,
+	+9.112493410125022978511686101672486662119e-0035L,
+	-6.504228206978548287230374775259388710985e-0035L,
+	-8.148468844525851137325691767488155323605e-0035L,
+	-5.066214576721800313372330745142903350963e-0035L,
+	-1.359830974688816973749875638245919118924e-0035L,
+	+9.497427635563196470307710566433246597109e-0035L,
+	-3.283170523176998601615065965333915261932e-0036L,
+	-5.017235709387190410290186530458428950862e-0035L,
+	-2.391474797689109171622834301602640139258e-0035L,
+	-8.350571357633908815298890737944083853080e-0036L,
+	+7.036756889073265042421737190671876440729e-0035L,
+	-5.182484853064646457536893018566956189817e-0035L,
+	+9.422242548621832065692116736394064879758e-0035L,
+	-3.967500825398862309167306130216418281103e-0035L,
+	+7.143528991563300614523273615092767243521e-0035L,
+	+1.159871252867985124246517834100444327747e-0035L,
+	+4.696933478358115495309739213201874466685e-0035L,
+	-3.386513175995004710799241984999819165197e-0035L,
+	-8.587318774298247068868655935103874453522e-0035L,
+	-9.605951548749350503185499362246069088835e-0035L,
+	+9.609733932128012784507558697141785813655e-0035L,
+	+6.378397921440028439244761449780848545957e-0035L,
+	+7.792430785695864249456461125169277701177e-0035L,
+	+7.361337767588456524131930836633932195088e-0035L,
+	-6.472995147913347230035214575612170525266e-0035L,
+	+8.587474417953698694278798062295229624207e-0035L,
+	+2.371815422825174835691651228302690977951e-0035L,
+	-3.026891682096118773004597373421900314256e-0037L,
+};