--- /dev/null	Sat May 10 12:09:02 2014
+++ new/usr/src/lib/libm/common/Q/_TBL_logl.c	Sat May 10 12:09:02 2014
@@ -0,0 +1,169 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+ */
+/*
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*
+ * Table of constants for logl.
+ * By K.C. Ng, March 9, 1989
+ */
+
+#include "libm.h"
+
+const long double _TBL_logl_hi[] = {
+	+0.000000000000000000000000000000000000000e+0000L,
+	+1.550418653596525415085404409320395875274e-0002L,
+	+3.077165866675368837102820454313423549427e-0002L,
+	+4.580953603129420316667926449525231301634e-0002L,
+	+6.062462181643484258060612972483742997442e-0002L,
+	+7.522342123758752569860532039086827578824e-0002L,
+	+8.961215868968713261995143730528787027578e-0002L,
+	+1.037967936816435648260617694803438348244e-0001L,
+	+1.177830356563834545387940581504548168563e-0001L,
+	+1.315763577887192725887160624312135596698e-0001L,
+	+1.451820098444978972819350572286183123887e-0001L,
+	+1.586050301766385840933711683530052981349e-0001L,
+	+1.718502569266592223400988812516892523599e-0001L,
+	+1.849223384940119926639035059723077314615e-0001L,
+	+1.978257433299198803625720374533782925763e-0001L,
+	+2.105647691073496376695527531626088702497e-0001L,
+	+2.231435513142097557662949937027997104032e-0001L,
+	+2.355660713127669090775881163009096337126e-0001L,
+	+2.478361639045812567806026867952720081699e-0001L,
+	+2.599575244369260669720794933085231739065e-0001L,
+	+2.719337154836417588316694242031136685288e-0001L,
+	+2.837681731306445983469010458794547135312e-0001L,
+	+2.954642128938358763866817700916107535002e-0001L,
+	+3.070250352949118620751243666552419834311e-0001L,
+	+3.184537311185346158102471140686078561531e-0001L,
+	+3.297532863724679818144228014362478784488e-0001L,
+	+3.409265869705932103050890001544662426952e-0001L,
+	+3.519764231571781846554474552048254288130e-0001L,
+	+3.629054936893684531378242945398272521523e-0001L,
+	+3.737164097935840808210167331226757525499e-0001L,
+	+3.844116989103320397347900487369508110320e-0001L,
+	+3.949938082408689781063939783520655318915e-0001L,
+	+4.054651081081643819780130322994137932204e-0001L,
+	+4.158278951437109656133288259511744826605e-0001L,
+	+4.260843953109000631245447385569842356371e-0001L,
+	+4.362367667749180703490412239178509575736e-0001L,
+	+4.462871026284195115325899874055994208063e-0001L,
+	+4.562374334815875943808053840818705719756e-0001L,
+	+4.660897299245992245586191878736453654769e-0001L,
+	+4.758459048699639142652093893677655824436e-0001L,
+	+4.855078157817008078017910633011255535046e-0001L,
+	+4.950772667978515145979645213034899480604e-0001L,
+	+5.045560107523952870583081828817948816463e-0001L,
+	+5.139457511022343168010058668287669524912e-0001L,
+	+5.232481437645478365168069353535037563840e-0001L,
+	+5.324647988694718438739234379583263151144e-0001L,
+	+5.415972824327443715765422111689841356847e-0001L,
+	+5.506471179526622792599479861304555364807e-0001L,
+	+5.596157879354226862708883466532843603287e-0001L,
+	+5.685047353526687120787385804082945993734e-0001L,
+	+5.773153650348236043181117067559499073234e-0001L,
+	+5.860490450035782089041193916402035316840e-0001L,
+	+5.947071077466927895143434959005658134879e-0001L,
+	+6.032908514380842623405849663552155166682e-0001L,
+	+6.118015411059929035298897608882125523626e-0001L,
+	+6.202404097518575288514942954323627943283e-0001L,
+	+6.286086594223741377443081293997900727520e-0001L,
+	+6.369074622370692316204942281372157123062e-0001L,
+	+6.451379613735847016652282983340864160916e-0001L,
+	+6.533012720127456387586157190946858013903e-0001L,
+	+6.613984822453650082602354487776933060928e-0001L,
+	+6.694306539426292672988850845059757003379e-0001L,
+	+6.773988235918061408096824565025274617492e-0001L,
+	+6.853040030989194165440476699956951850629e-0001L,
+};
+
+const long double _TBL_logl_lo[] = {
+	+0.000000000000000000000000000000000000000e+0000L,
+	+1.949242877125126389030374148355277037360e-0027L,
+	+3.053637928597425156289800058830629052349e-0027L,
+	+3.119411029097592549724599219796579698355e-0027L,
+	+2.315582833311779694729302029874044004747e-0027L,
+	+1.959279413884862919696230642481001644914e-0026L,
+	+3.207319665850940689112590931321584585232e-0026L,
+	+3.428363085348215886901240200560690191423e-0026L,
+	+5.132006688821218644279793035639158591104e-0026L,
+	+6.625826960278191623061313902987136675670e-0026L,
+	+6.511946011133829904478213998927380817716e-0027L,
+	+6.272836277110805877048126233548710095828e-0027L,
+	+6.480345801257546326311423010001184801374e-0026L,
+	+8.668694188954430256018491855337005516255e-0026L,
+	+3.374358317649896753533582921130800923337e-0026L,
+	+5.956974264347082186429247944518667757530e-0026L,
+	+9.660703479297144864941461785565180191497e-0026L,
+	+1.026401337764243728855958607127831718221e-0025L,
+	+7.895125273982903351541822547625351974082e-0026L,
+	+1.233787870669833985274611329531652753861e-0027L,
+	+7.032988549345377674736424478296516377526e-0026L,
+	+1.764708000531295728633384847670848625081e-0025L,
+	+1.359633534416813878749988462341486606257e-0025L,
+	+1.738801359182578816100029030519562527565e-0025L,
+	+9.952199173944211463901058384143333287734e-0026L,
+	+1.048454193250289008158931842356333139861e-0026L,
+	+1.996258899657478647716755914664160562170e-0025L,
+	+1.054613497176328160439100383508915283893e-0027L,
+	+5.143766259398803158035428613944687700657e-0026L,
+	+9.959314775409457843445608446369116918733e-0026L,
+	+1.374434005748650164937032849496159512584e-0026L,
+	+5.801291623641845255360276144691829323298e-0026L,
+	+8.316493534335158882618991007102844149005e-0026L,
+	+6.700372782269538472749252935215499311080e-0026L,
+	+1.410384923832595967313936024639114199873e-0025L,
+	+9.914327034309007140234547094345224044051e-0026L,
+	+1.932140695859428972988292357113036038299e-0025L,
+	+1.540820591764623257530922632028001952748e-0025L,
+	+5.963112403438125368118769047371614538741e-0026L,
+	+1.969366158297316138140115855981754471320e-0025L,
+	+1.388966334707414023926476567157219393213e-0026L,
+	+6.353934371729676603785277612987160899450e-0026L,
+	+3.488563800483361999633395030516586696799e-0025L,
+	+2.214454506406188993139159148705861598088e-0025L,
+	+2.895813670852564643073769701905380524878e-0025L,
+	+2.855018159274929532107406110765900047355e-0025L,
+	+9.273144996328510392949911518833977809658e-0026L,
+	+1.930744579236138780895942105787011752697e-0025L,
+	+1.538735422331574088102192677519746877453e-0025L,
+	+1.844586676642028985383989272409206538468e-0025L,
+	+3.547635464941839708071563131885310128521e-0025L,
+	+4.464712081783102087084281748635332222581e-0026L,
+	+5.062863951970459495500575300347508324877e-0026L,
+	+2.203060950889790157204518257910818074191e-0025L,
+	+5.540602231323196163388428517126435254723e-0027L,
+	+3.371348840624439923830692211721531149909e-0025L,
+	+7.637439356719457811667844141793488670929e-0026L,
+	+1.990439834788842292780211676828666657547e-0025L,
+	+1.978006454898465493718923085569873769719e-0025L,
+	+1.621161880831806223416081355472819612309e-0025L,
+	+3.899319576320551292151632804501913965920e-0025L,
+	+1.864235278097858865893177670582100390924e-0025L,
+	+1.534948208368053655735541548539936152221e-0025L,
+	+4.089715378013580174759550633443176148182e-0025L,
+};